local addon, Engine = ...
---@type DE
local DE = Engine.Core
local L = Engine.L

local format, ipairs, min, pairs, select, strsplit, tonumber = format, ipairs, min, pairs, select, strsplit, tonumber

---@type raidSpellTable
local RaidSpells = {

    -- The Tarragrue
    [347274] = true, -- Annihilating Smash
    [347671] = true, -- Hungering Mist

    -- The Eye of the Jailer
    [350028] = true, -- Fracture Soul
    [350034] = {isDot = true}, -- Fractured Soul
    [350763] = true, -- Annihilating Glare

    -- The Nine
    [350374] = {debuffIsFail = true}, -- Wings of Rage
    [352757] = {debuffIsFail = true}, -- Wings of Rage (2)
    [352753] = {debuffIsFail = true}, -- Reverberating Refrain
    [350462] = {debuffIsFail = true}, -- Reverberating Refrain (2)
    [350031] = true, -- Agatha's Eternal Blade
    [350185] = true, -- Daschla's Mighty Impact
    [351142] = true, -- Brynja's Mournful Dirge
    [350555] = true, -- Shard of Destiny

    -- Remnant of Ner'zhul
    [349890] = {ignoreTanks = true}, -- Suffering
    [357812] = {ignoreTanks = true}, -- Suffering
    [358442] = {ignoreTanks = true}, -- Suffering
    [350076] = true, -- Grasp of Malice
    [354479] = {debuffIsFail = true}, -- Spite
    [354634] = {debuffIsFail = true}, -- Spite
    [354534] = {debuffIsFail = true}, -- Spite

    -- Soulrender Dormazain
    -- TODO

    -- Painsmith Raznal
    -- TODO

    -- Guardian of the First Ones
    -- TODO

    -- Fatescribe Roh-Kalo
    -- TODO

    -- Kel'Thuzad
    -- TODO

    -- Sylvanas Windrunner <3
    -- P1
    [356377] = true, -- Desecrating Shot
    [352318] = true, -- Domination Chains (impact)
    [356649] = true, -- Calamity
    [350777] = true, -- Veil of Darkness
    [357726] = true, -- Veil of Darkness
    -- Intermission
    [348145] = true, -- Rive
    [353413] = true, -- Riven Debris
    -- P2
    [351870] = {debuffIsFail = true, isDot = true}, -- Haunting Wave
    [347670] = {isDot = true, debuffIsFail = true}, -- Shadow Dagger
    [351075] = true, -- Unstoppable Force (Mawsworn Vanguard)
    -- P3
    [353972] = true, -- Bane Arrows    

}

---@type auraTrackTable
local AurasToTrack = {

    -- The Tarragrue
    [347274] = {debuff = true, isFail = true}, -- Annihilating Smash stun
    [347286] = {debuff = true, isFail = true}, -- Unshakeable Dread

    -- The Eye of the Jailer

    -- The Nine

    -- Remnant of Ner'zhul

    -- Soulrender Dormazain
    -- TODO

    -- Painsmith Raznal
    -- TODO

    -- Guardian of the First Ones
    -- TODO

    -- Fatescribe Roh-Kalo
    -- TODO

    -- Kel'Thuzad
    -- TODO

    -- Sylvanas Windrunner <3

}

local autoGeneratedTracker = DE:GenerateAuraTrackerFromSpells(RaidSpells)
DE:MergeTables(AurasToTrack, autoGeneratedTracker, false)

DE:MergeTables(DE.RaidSpells, RaidSpells)
DE:MergeTables(DE.AuraTracker, AurasToTrack)
